#ifndef __NEO_Port_hh_seen
#define __NEO_Port_hh_seen
namespace neo {
namespace cca {

/** A pure-virtual tag interface to identify a function set capable 
 * of being exported to or imported from a CCA component.
 * Memory lifecycle:
 * Ports are not reference counted by the framework or by
 * the components that get them through getPort, since their
 * existence is guaranteed until all needed releasePort calls
 * have been made and a successful removeProvidesPort call
 * is made. Once removed, deallocation (if any is needed separate
 * from the component destruction) is the responsibility
 * of the code which calls removeProvidesPort.
 */
class Port 
{
public:
  
  /** obligatory virtual destructor */
  virtual ~Port (){}
};

}  // end namespace cca
}  // end namespace neo

#endif // __NEO_Port_hh_seen
