#ifndef neo_TypeMismatchException_hh_seen
#define neo_TypeMismatchException_hh_seen

/* A file of auxiliaries that mainly distract the new reader.  */

namespace neo {
namespace cca {


/** Exception occuring when a get or put operation
 * specifies incorrect data type for a given key already defined
 * in the map.
 */
class TypeMismatchException : public Exception
{
private:
	enum Type rt;
	enum Type at;

public:

  TypeMismatchException(enum Type requestedType, enum Type actualType, const ::std::string & message)
  {
    rt = requestedType;
    at = actualType;
    setMessage(message);
    setType(Nonstandard);
  }

  virtual ~TypeMismatchException() throw (){}

  /** @return the enumerated value Type sought */
  Type getRequestedType() { return rt; }
  /** @return the enumerated value Type sought */
  Type getActualType() { return at; }
	 
};
    
}  // end namespace cca
}  // end namespace neo

#endif // neo_TypeMismatchException_hh_seen
