#ifndef neo_Version_hh_seen
#define neo_Version_hh_seen
namespace neo {
namespace cca {

/** runtime version info for queries. */
class Version 
{
public:

  /** The descriptive source release string. */
  static std::string name(); 

  /** The dot notation release number string; major.minor.patch.  */
  static std::string id();

  /**@ Revision numbering scheme will be rigorously followed after
       1.0.0.
   */
  //@{

  /** Major version; increments with binary incompatible changes 
      in this header. */
  static int Major(); 

  /** Minor revision; increments with binary incompatible changes in
      well known ports, including changes in namings expressed with
      string name or type arguments. Changes in the spec but outside
      this header. */
  static int Minor(); 

  /** Patch revision; binary compatible changes, such as addition of
      new common port definitions. */
  static int Patch(); 

  //@}
};

}  // end namespace cca
}  // end namespace neo

#endif // neo_Version_hh_seen
