#ifndef __neoJPRINTFPORT_H__
#define __neoJPRINTFPORT_H__

namespace neo {
namespace cca {
namespace ports {

/** 
 * "neo.cca.ports.JPrintfPort: a port for making a string go to
 * one of three channel, which may be routed
 * anywhere by the framework or providing component (UNADOPTED
 * in the standard).
 */
class JPrintfPort : public virtual neo::cca::Port {
private:
public:

	
  /** obligatory vdtor */
  virtual ~JPrintfPort(){}

  /** Output a string on out device  */
  virtual void p(char* msg)= 0;
  /** Output a string on out device  */
  virtual void p(const char * msg)= 0;
  /** Output a string on out device with added \n  */
  virtual void pn(char * msg)= 0;
  /** Output a string on out device with added \n  */
  virtual void pn(const char * msg)= 0;

  /** Output a string on err device  */
  virtual void e(char* msg)= 0;
  /** Output a string on err device  */
  virtual void e(const char* msg)= 0;
  /** Output a string on err device with added \n  */
  virtual void en(char* msg)= 0;
  /** Output a string on err device with added \n  */
  virtual void en(const char* msg)= 0;

  /** Output a string on log device  */
  virtual void l(char* msg)= 0;
  /** Output a string on log device  */
  virtual void l(const char* msg)= 0;
  /** Output a string on log device with added \n  */
  virtual void ln(char* msg)= 0;
  /** Output a string on log device with added \n  */
  virtual void ln(const char* msg)= 0;

  /** Output a string on out device  */
  virtual void p(const std::string & msg)= 0;
  /** Output a string on out device with added \n  */
  virtual void pn(const std::string & msg)= 0;

  /** Output a string on err device  */
  virtual void e(const std::string & msg)= 0;
  /** Output a string on err device with added \n  */
  virtual void en(const std::string & msg)= 0;

  /** Output a string on log device  */
  virtual void l(const std::string & msg)= 0;
  /** Output a string on log device with added \n  */
  virtual void ln(const std::string & msg)= 0;

};

}  // end namespace ports
}  // end namespace cca
}  // end namespace neo

#endif //__neoJPRINTFPORT_H__
