#ifndef neoMPIService_h_seen
#define neoMPIService_h_seen

//requires:
//#include <neocca.h>
//#include <mpi.h>
#ifdef MPI_COMM_NULL // this file is empty if mpi.h is not included


namespace neo {
namespace cca {
namespace ports {

/** 
 * "neo.cca.ports.MPIService": 
 * UNADOPTED-standard service for getting a private mpi comm.
 */
class MPIService : public virtual neo::cca::Port {
private:
public:

	
  /** obligatory vdtor */
  virtual ~MPIService() {}

  /** Get an mpi communicator with the same scope as the component instance.
   Won't be mpi_comm_null. The communicator returned will be
   private to the recipient, which implies an mpicommdup.
   */
  virtual MPI_Comm getComm()= 0;

  /** Let go the communicator. previously fetched with getComm. */
  virtual void releaseComm(MPI_Comm m)= 0;

};

}  // end namespace ports
}  // end namespace cca
}  // end namespace neo

#endif // MPI_CONGRUENT 
#endif // neoMPIService_h_seen
