#ifndef neo_support_ComponentClassDescription_hh_seen
#define neo_support_ComponentClassDescription_hh_seen

namespace neo {
namespace support {

class ComponentClassDescription;

typedef boost::shared_ptr< ComponentClassDescription > ComponentClassDescription_shared;

/**
 * implementation that can be reused by factory providers
 * independent of Ccafe internals.
 */
class ComponentClassDescription : public virtual neo::cca::ports::ComponentClassDescription
{

private:
	std::string name;
	std::string alias;

public:
	/** this is the constructor everyone should use,
	 * as it provides the reference counted,
	 * spec-compliant version.
	 */
	static neo::cca::ports::ComponentClassDescription_shared create( std::string className, std::string classAlias );

	/** neo bound description. */
	ComponentClassDescription( std::string className, std::string classAlias);

	virtual ~ComponentClassDescription();

	virtual ::std::string getComponentClassName() throw();
	virtual ::std::string getDeploymentClassAlias() throw();
	virtual ::std::string getCCASpecBinding() throw();

};

}   // end namespace support
}   // end namespace neo

#endif // neo_support_ComponentClassDescription_hh_seen
