#ifndef __neoSIMPLESTAMPSTRING_H__
#define __neoSIMPLESTAMPSTRING_H__

namespace eg {
namespace neo {

/** An example component that takes an input string and stamps it with
    a time string, then puts it on output. */
class SimpleStamper: public virtual ::neo::cca::Component, 
                   public virtual ::neo::cca::ComponentRelease, 
		   public virtual ::neo::cca::ports::GoPort,
		   public virtual ::eg::neo::ports::StringOutPort {
		   
private:
  ::neo::cca::Services* svc;
  ::eg::neo::ports::TimeSourcePort *time;

public:

  /** Spec required null constructor. */
  SimpleStamper();

  /** required virtualness on destructor. */
  virtual ~SimpleStamper();

  /** Implements neo::cca::Component. */
  virtual void setServices( ::neo::cca::Services *svc) throw (::neo::cca::Exception); 

  /** Implements neo::cca::ComponentRelease. */
  virtual void releaseServices( ::neo::cca::Services *svc) throw (::neo::cca::Exception); 

  /** Implements StringConsumerPort */
  virtual void setString( const std::string & s);

  /** can call another instance of self. */
  virtual int go(); 

};

}  // end namespace neo
}  // end namespace eg

extern "C" {
/** required c-style constructor for dynamic loading. */
neo::cca::Component *create_eg_neo_SimpleStamper();
}

#endif // __neoSIMPLESTAMPSTRING_H__
