#ifndef __STRINGOUTPORT_H__
#define __STRINGOUTPORT_H__

#include <string>

namespace eg {
namespace neo {
namespace ports {

/** An example port for a standard interface for passing a string 
    to a component. The canonical string name of this port is 
    "eg.neo.ports.StringOutPort". 
*/
class StringOutPort : public virtual ::neo::cca::Port {
private:
public:
  /** obligatory vdtor */
  virtual ~StringOutPort(){}

  /** Pass a string to the component. */
  virtual void setString(const std::string & s) = 0;
};


}  // end namespace ports
}  // end namespace neo
}  // end namespace eg


#endif // __STRINGOUTPORT_H__
